function [ sae1OptTheta,fAll ] = stackedSAEUnsup(data,hiddenSize,maxIter,...
    SkNN,degs,L,lambda,mu,sparsityParam,gamma,beta)

fprintf('# examples in data set: %d\n',size(data,2))

visibleSize = size(data,1);

%  Randomly initialize the parameters
disp('neural network weight initialization...')
if ~exist('./thetaInit/','dir')
    mkdir('./thetaInit/')
end
if ~exist(['./thetaInit/sae1Theta_' num2str(visibleSize) '_' ...
        num2str(hiddenSize) '.mat'],'file')
    sae1Theta = initializeParameters(hiddenSize,visibleSize);
    save(['./thetaInit/sae1Theta_' num2str(visibleSize) '_' ...
        num2str(hiddenSize) '.mat'],'sae1Theta')
else
    load(['./thetaInit/sae1Theta_' num2str(visibleSize) '_' ...
        num2str(hiddenSize) '.mat'])
end

disp('neural network weight training...')

% Train optimal network parameters
addpath minFunc/
options.Method = 'lbfgs';
options.maxIter = maxIter;
options.display = 'off';
[sae1OptTheta,fAll] = minFunc(@(p)sparseAutoencoderCost(p,visibleSize,...
    hiddenSize,lambda,mu,sparsityParam,beta,data,L,gamma),...
    sae1Theta,options);

end